--
-- Parser for extracting references out of *.rsf files
--
-- Author: Wolfgang Scholz, 2010-06
--
module RSF where
import Char
import FeatureStructure
import Data.List

-- parser produced by Happy Version 1.17

data HappyAbsSyn 
	= HappyTerminal Token
	| HappyErrorToken Int
	| HappyAbsSyn4 (([ReferenceExpl]))
	| HappyAbsSyn5 (ReferenceExpl)
	| HappyAbsSyn6 (())

type HappyReduction m = 
	   Int 
	-> (Token)
	-> HappyState (Token) (HappyStk HappyAbsSyn -> [(Token)] -> m HappyAbsSyn)
	-> [HappyState (Token) (HappyStk HappyAbsSyn -> [(Token)] -> m HappyAbsSyn)] 
	-> HappyStk HappyAbsSyn 
	-> [(Token)] -> m HappyAbsSyn

action_0,
 action_1,
 action_2,
 action_3,
 action_4,
 action_5,
 action_6,
 action_7,
 action_8,
 action_9,
 action_10,
 action_11,
 action_12,
 action_13,
 action_14,
 action_15,
 action_16,
 action_17,
 action_18,
 action_19,
 action_20,
 action_21,
 action_22,
 action_23,
 action_24,
 action_25,
 action_26,
 action_27,
 action_28,
 action_29,
 action_30,
 action_31,
 action_32,
 action_33,
 action_34,
 action_35,
 action_36,
 action_37,
 action_38,
 action_39,
 action_40,
 action_41,
 action_42,
 action_43,
 action_44,
 action_45,
 action_46,
 action_47,
 action_48,
 action_49,
 action_50,
 action_51,
 action_52,
 action_53,
 action_54,
 action_55,
 action_56,
 action_57,
 action_58,
 action_59,
 action_60,
 action_61,
 action_62,
 action_63,
 action_64,
 action_65,
 action_66,
 action_67,
 action_68,
 action_69,
 action_70,
 action_71,
 action_72,
 action_73,
 action_74,
 action_75,
 action_76,
 action_77,
 action_78,
 action_79,
 action_80,
 action_81,
 action_82,
 action_83,
 action_84,
 action_85,
 action_86,
 action_87,
 action_88,
 action_89,
 action_90,
 action_91,
 action_92,
 action_93,
 action_94,
 action_95,
 action_96,
 action_97,
 action_98,
 action_99,
 action_100,
 action_101,
 action_102,
 action_103,
 action_104 :: () => Int -> HappyReduction (HappyIdentity)

happyReduce_1,
 happyReduce_2,
 happyReduce_3,
 happyReduce_4,
 happyReduce_5,
 happyReduce_6,
 happyReduce_7,
 happyReduce_8,
 happyReduce_9,
 happyReduce_10,
 happyReduce_11,
 happyReduce_12,
 happyReduce_13,
 happyReduce_14,
 happyReduce_15,
 happyReduce_16,
 happyReduce_17,
 happyReduce_18,
 happyReduce_19,
 happyReduce_20,
 happyReduce_21,
 happyReduce_22,
 happyReduce_23,
 happyReduce_24,
 happyReduce_25,
 happyReduce_26,
 happyReduce_27,
 happyReduce_28,
 happyReduce_29,
 happyReduce_30,
 happyReduce_31,
 happyReduce_32,
 happyReduce_33,
 happyReduce_34,
 happyReduce_35,
 happyReduce_36,
 happyReduce_37,
 happyReduce_38,
 happyReduce_39,
 happyReduce_40 :: () => HappyReduction (HappyIdentity)

action_0 (7) = happyShift action_10
action_0 (8) = happyShift action_11
action_0 (9) = happyShift action_12
action_0 (10) = happyShift action_13
action_0 (11) = happyShift action_14
action_0 (12) = happyShift action_15
action_0 (13) = happyShift action_3
action_0 (14) = happyShift action_4
action_0 (15) = happyShift action_16
action_0 (16) = happyShift action_17
action_0 (17) = happyShift action_5
action_0 (18) = happyShift action_6
action_0 (4) = happyGoto action_7
action_0 (5) = happyGoto action_8
action_0 (6) = happyGoto action_9
action_0 _ = happyFail

action_1 (13) = happyShift action_3
action_1 (14) = happyShift action_4
action_1 (17) = happyShift action_5
action_1 (18) = happyShift action_6
action_1 (5) = happyGoto action_2
action_1 _ = happyFail

action_2 (7) = happyShift action_10
action_2 (8) = happyShift action_11
action_2 (9) = happyShift action_12
action_2 (10) = happyShift action_13
action_2 (11) = happyShift action_14
action_2 (12) = happyShift action_15
action_2 (13) = happyShift action_3
action_2 (14) = happyShift action_4
action_2 (15) = happyShift action_16
action_2 (16) = happyShift action_17
action_2 (17) = happyShift action_5
action_2 (18) = happyShift action_6
action_2 (4) = happyGoto action_27
action_2 (5) = happyGoto action_8
action_2 (6) = happyGoto action_9
action_2 _ = happyFail

action_3 (20) = happyShift action_31
action_3 _ = happyFail

action_4 (20) = happyShift action_30
action_4 _ = happyFail

action_5 (20) = happyShift action_29
action_5 _ = happyFail

action_6 (20) = happyShift action_28
action_6 _ = happyFail

action_7 (21) = happyAccept
action_7 _ = happyFail

action_8 (7) = happyShift action_10
action_8 (8) = happyShift action_11
action_8 (9) = happyShift action_12
action_8 (10) = happyShift action_13
action_8 (11) = happyShift action_14
action_8 (12) = happyShift action_15
action_8 (13) = happyShift action_3
action_8 (14) = happyShift action_4
action_8 (15) = happyShift action_16
action_8 (16) = happyShift action_17
action_8 (17) = happyShift action_5
action_8 (18) = happyShift action_6
action_8 (4) = happyGoto action_27
action_8 (5) = happyGoto action_8
action_8 (6) = happyGoto action_9
action_8 _ = happyReduce_3

action_9 (7) = happyShift action_10
action_9 (8) = happyShift action_11
action_9 (9) = happyShift action_12
action_9 (10) = happyShift action_13
action_9 (11) = happyShift action_14
action_9 (12) = happyShift action_15
action_9 (13) = happyShift action_3
action_9 (14) = happyShift action_4
action_9 (15) = happyShift action_16
action_9 (16) = happyShift action_17
action_9 (17) = happyShift action_5
action_9 (18) = happyShift action_6
action_9 (4) = happyGoto action_26
action_9 (5) = happyGoto action_8
action_9 (6) = happyGoto action_9
action_9 _ = happyReduce_4

action_10 (20) = happyShift action_25
action_10 _ = happyFail

action_11 (20) = happyShift action_24
action_11 _ = happyFail

action_12 (20) = happyShift action_23
action_12 _ = happyFail

action_13 (20) = happyShift action_22
action_13 _ = happyFail

action_14 (20) = happyShift action_21
action_14 _ = happyFail

action_15 (20) = happyShift action_20
action_15 _ = happyFail

action_16 (20) = happyShift action_19
action_16 _ = happyFail

action_17 (20) = happyShift action_18
action_17 _ = happyFail

action_18 (20) = happyShift action_49
action_18 _ = happyFail

action_19 (19) = happyShift action_47
action_19 (20) = happyShift action_48
action_19 _ = happyFail

action_20 (20) = happyShift action_46
action_20 _ = happyFail

action_21 (20) = happyShift action_45
action_21 _ = happyFail

action_22 (20) = happyShift action_44
action_22 _ = happyFail

action_23 (20) = happyShift action_43
action_23 _ = happyFail

action_24 (19) = happyShift action_41
action_24 (20) = happyShift action_42
action_24 _ = happyFail

action_25 (20) = happyShift action_40
action_25 _ = happyFail

action_26 _ = happyReduce_2

action_27 _ = happyReduce_1

action_28 (19) = happyShift action_38
action_28 (20) = happyShift action_39
action_28 _ = happyFail

action_29 (19) = happyShift action_36
action_29 (20) = happyShift action_37
action_29 _ = happyFail

action_30 (19) = happyShift action_34
action_30 (20) = happyShift action_35
action_30 _ = happyFail

action_31 (19) = happyShift action_32
action_31 (20) = happyShift action_33
action_31 _ = happyFail

action_32 (20) = happyShift action_67
action_32 _ = happyFail

action_33 (19) = happyShift action_66
action_33 _ = happyReduce_5

action_34 (20) = happyShift action_65
action_34 _ = happyFail

action_35 (19) = happyShift action_64
action_35 _ = happyReduce_9

action_36 (20) = happyShift action_63
action_36 _ = happyFail

action_37 (19) = happyShift action_62
action_37 _ = happyReduce_13

action_38 (20) = happyShift action_61
action_38 _ = happyFail

action_39 (19) = happyShift action_60
action_39 _ = happyReduce_17

action_40 (19) = happyShift action_58
action_40 (20) = happyShift action_59
action_40 _ = happyFail

action_41 (20) = happyShift action_57
action_41 _ = happyFail

action_42 (19) = happyShift action_56
action_42 _ = happyReduce_25

action_43 (19) = happyShift action_54
action_43 (20) = happyShift action_55
action_43 _ = happyFail

action_44 (20) = happyShift action_53
action_44 _ = happyFail

action_45 (20) = happyShift action_52
action_45 _ = happyFail

action_46 _ = happyReduce_39

action_47 (20) = happyShift action_51
action_47 _ = happyFail

action_48 (19) = happyShift action_50
action_48 _ = happyReduce_33

action_49 _ = happyReduce_40

action_50 (20) = happyShift action_84
action_50 _ = happyFail

action_51 (20) = happyShift action_83
action_51 _ = happyFail

action_52 _ = happyReduce_38

action_53 (20) = happyShift action_82
action_53 _ = happyFail

action_54 (20) = happyShift action_81
action_54 _ = happyFail

action_55 (19) = happyShift action_80
action_55 _ = happyReduce_29

action_56 (20) = happyShift action_79
action_56 _ = happyFail

action_57 (20) = happyShift action_78
action_57 _ = happyFail

action_58 (20) = happyShift action_77
action_58 _ = happyFail

action_59 (19) = happyShift action_76
action_59 _ = happyReduce_21

action_60 (20) = happyShift action_75
action_60 _ = happyFail

action_61 (20) = happyShift action_74
action_61 _ = happyFail

action_62 (20) = happyShift action_73
action_62 _ = happyFail

action_63 (20) = happyShift action_72
action_63 _ = happyFail

action_64 (20) = happyShift action_71
action_64 _ = happyFail

action_65 (20) = happyShift action_70
action_65 _ = happyFail

action_66 (20) = happyShift action_69
action_66 _ = happyFail

action_67 (20) = happyShift action_68
action_67 _ = happyFail

action_68 (19) = happyShift action_94
action_68 _ = happyReduce_6

action_69 _ = happyReduce_7

action_70 (19) = happyShift action_93
action_70 _ = happyReduce_10

action_71 _ = happyReduce_11

action_72 (19) = happyShift action_92
action_72 _ = happyReduce_14

action_73 _ = happyReduce_15

action_74 (19) = happyShift action_91
action_74 _ = happyReduce_18

action_75 _ = happyReduce_19

action_76 (20) = happyShift action_90
action_76 _ = happyFail

action_77 (20) = happyShift action_89
action_77 _ = happyFail

action_78 (19) = happyShift action_88
action_78 _ = happyReduce_26

action_79 _ = happyReduce_27

action_80 (20) = happyShift action_87
action_80 _ = happyFail

action_81 (20) = happyShift action_86
action_81 _ = happyFail

action_82 _ = happyReduce_37

action_83 (19) = happyShift action_85
action_83 _ = happyReduce_35

action_84 _ = happyReduce_34

action_85 (20) = happyShift action_102
action_85 _ = happyFail

action_86 (19) = happyShift action_101
action_86 _ = happyReduce_30

action_87 _ = happyReduce_31

action_88 (20) = happyShift action_100
action_88 _ = happyFail

action_89 (19) = happyShift action_99
action_89 _ = happyReduce_22

action_90 _ = happyReduce_23

action_91 (20) = happyShift action_98
action_91 _ = happyFail

action_92 (20) = happyShift action_97
action_92 _ = happyFail

action_93 (20) = happyShift action_96
action_93 _ = happyFail

action_94 (20) = happyShift action_95
action_94 _ = happyFail

action_95 _ = happyReduce_8

action_96 _ = happyReduce_12

action_97 _ = happyReduce_16

action_98 _ = happyReduce_20

action_99 (20) = happyShift action_104
action_99 _ = happyFail

action_100 _ = happyReduce_28

action_101 (20) = happyShift action_103
action_101 _ = happyFail

action_102 _ = happyReduce_36

action_103 _ = happyReduce_32

action_104 _ = happyReduce_24

happyReduce_1 = happySpecReduce_2  4 happyReduction_1
happyReduction_1 (HappyAbsSyn4  happy_var_2)
	(HappyAbsSyn5  happy_var_1)
	 =  HappyAbsSyn4
		 (happy_var_1 : happy_var_2
	)
happyReduction_1 _ _  = notHappyAtAll 

happyReduce_2 = happySpecReduce_2  4 happyReduction_2
happyReduction_2 (HappyAbsSyn4  happy_var_2)
	_
	 =  HappyAbsSyn4
		 (happy_var_2
	)
happyReduction_2 _ _  = notHappyAtAll 

happyReduce_3 = happySpecReduce_1  4 happyReduction_3
happyReduction_3 (HappyAbsSyn5  happy_var_1)
	 =  HappyAbsSyn4
		 ([happy_var_1]
	)
happyReduction_3 _  = notHappyAtAll 

happyReduce_4 = happySpecReduce_1  4 happyReduction_4
happyReduction_4 _
	 =  HappyAbsSyn4
		 ([]
	)

happyReduce_5 = happySpecReduce_3  5 happyReduction_5
happyReduction_5 (HappyTerminal (TokenElem happy_var_3))
	(HappyTerminal (TokenElem happy_var_2))
	_
	 =  HappyAbsSyn5
		 ((
          ("", Element{elName=unBrk2 happy_var_2,elType="MethodDecl",value=""}),
          (Element{elName=unBrk2 happy_var_3,elType="FieldDecl",value=""}))
	)
happyReduction_5 _ _ _  = notHappyAtAll 

happyReduce_6 = happyReduce 5 5 happyReduction_6
happyReduction_6 ((HappyTerminal (TokenElem happy_var_5)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          (unBrk happy_var_4, Element{elName=happy_var_2,elType="MethodDecl",value=""}),
          (Element{elName=unBrk2 happy_var_5,elType="FieldDecl",value=""}))
	) `HappyStk` happyRest

happyReduce_7 = happyReduce 5 5 happyReduction_7
happyReduction_7 (_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_3)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          ("", Element{elName=unBrk2 happy_var_2,elType="MethodDecl",value=""}),
          (Element{elName=happy_var_3,elType="FieldDecl",value=""}))
	) `HappyStk` happyRest

happyReduce_8 = happyReduce 7 5 happyReduction_8
happyReduction_8 (_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_5)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          (unBrk happy_var_4, Element{elName=unBrk2 happy_var_2,elType="MethodDecl",value=""}),
          (Element{elName=unBrk2 happy_var_5,elType="FieldDecl",value=""}))
	) `HappyStk` happyRest

happyReduce_9 = happySpecReduce_3  5 happyReduction_9
happyReduction_9 (HappyTerminal (TokenElem happy_var_3))
	(HappyTerminal (TokenElem happy_var_2))
	_
	 =  HappyAbsSyn5
		 ((
          ("", Element{elName=unBrk2 happy_var_2,elType="MethodDecl",value=""}),
          (Element{elName=unBrk2 happy_var_3,elType="MethodDecl",value=""}))
	)
happyReduction_9 _ _ _  = notHappyAtAll 

happyReduce_10 = happyReduce 5 5 happyReduction_10
happyReduction_10 ((HappyTerminal (TokenElem happy_var_5)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          (unBrk happy_var_4, Element{elName=happy_var_2,elType="MethodDecl",value=""}),
          (Element{elName=unBrk2 happy_var_5,elType="MethodDecl",value=""}))
	) `HappyStk` happyRest

happyReduce_11 = happyReduce 5 5 happyReduction_11
happyReduction_11 (_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_3)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          ("", Element{elName=unBrk2 happy_var_2,elType="MethodDecl",value=""}),
          (Element{elName=happy_var_3,elType="MethodDecl",value=""}))
	) `HappyStk` happyRest

happyReduce_12 = happyReduce 7 5 happyReduction_12
happyReduction_12 (_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_5)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          (unBrk happy_var_4, Element{elName=happy_var_2,elType="MethodDecl",value=""}),
          (Element{elName=happy_var_5,elType="MethodDecl",value=""}))
	) `HappyStk` happyRest

happyReduce_13 = happySpecReduce_3  5 happyReduction_13
happyReduction_13 (HappyTerminal (TokenElem happy_var_3))
	(HappyTerminal (TokenElem happy_var_2))
	_
	 =  HappyAbsSyn5
		 ((
          ("", Element{elName=unBrk2 happy_var_2,elType="ClassDeclaration",value=""}),
          (Element{elName=unBrk2 happy_var_3,elType="ClassDeclaration",value=""}))
	)
happyReduction_13 _ _ _  = notHappyAtAll 

happyReduce_14 = happyReduce 5 5 happyReduction_14
happyReduction_14 ((HappyTerminal (TokenElem happy_var_5)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          (unBrk happy_var_4, Element{elName=happy_var_2,elType="ClassDeclaration",value=""}),
          (Element{elName=unBrk2 happy_var_5,elType="ClassDeclaration",value=""}))
	) `HappyStk` happyRest

happyReduce_15 = happyReduce 5 5 happyReduction_15
happyReduction_15 (_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_3)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          ("", Element{elName=unBrk2 happy_var_2,elType="ClassDeclaration",value=""}),
          (Element{elName=happy_var_3,elType="ClassDeclaration",value=""}))
	) `HappyStk` happyRest

happyReduce_16 = happyReduce 7 5 happyReduction_16
happyReduction_16 (_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_5)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          (unBrk happy_var_4, Element{elName=happy_var_2,elType="ClassDeclaration",value=""}),
          (Element{elName=happy_var_5,elType="ClassDeclaration",value=""}))
	) `HappyStk` happyRest

happyReduce_17 = happySpecReduce_3  5 happyReduction_17
happyReduction_17 (HappyTerminal (TokenElem happy_var_3))
	(HappyTerminal (TokenElem happy_var_2))
	_
	 =  HappyAbsSyn5
		 ((
          ("", Element{elName=unBrk2 happy_var_2,elType="ClassDeclaration",value=""}),
          (Element{elName=unBrk2 happy_var_3,elType="ClassDeclaration",value=""}))
	)
happyReduction_17 _ _ _  = notHappyAtAll 

happyReduce_18 = happyReduce 5 5 happyReduction_18
happyReduction_18 ((HappyTerminal (TokenElem happy_var_5)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          (unBrk happy_var_4, Element{elName=happy_var_2,elType="ClassDeclaration",value=""}),
          (Element{elName=unBrk2 happy_var_5,elType="ClassDeclaration",value=""}))
	) `HappyStk` happyRest

happyReduce_19 = happyReduce 5 5 happyReduction_19
happyReduction_19 (_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_3)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          ("", Element{elName=unBrk2 happy_var_2,elType="ClassDeclaration",value=""}),
          (Element{elName=happy_var_3,elType="ClassDeclaration",value=""}))
	) `HappyStk` happyRest

happyReduce_20 = happyReduce 7 5 happyReduction_20
happyReduction_20 (_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_5)) `HappyStk`
	(HappyTerminal (TokenElem happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenElem happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ((
          (unBrk happy_var_4, Element{elName=happy_var_2,elType="ClassDeclaration",value=""}),
          (Element{elName=happy_var_5,elType="ClassDeclaration",value=""}))
	) `HappyStk` happyRest

happyReduce_21 = happyReduce 4 6 happyReduction_21
happyReduction_21 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_22 = happyReduce 6 6 happyReduction_22
happyReduction_22 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_23 = happyReduce 6 6 happyReduction_23
happyReduction_23 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_24 = happyReduce 8 6 happyReduction_24
happyReduction_24 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_25 = happySpecReduce_3  6 happyReduction_25
happyReduction_25 _
	_
	_
	 =  HappyAbsSyn6
		 (()
	)

happyReduce_26 = happyReduce 5 6 happyReduction_26
happyReduction_26 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_27 = happyReduce 5 6 happyReduction_27
happyReduction_27 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_28 = happyReduce 7 6 happyReduction_28
happyReduction_28 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_29 = happyReduce 4 6 happyReduction_29
happyReduction_29 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_30 = happyReduce 6 6 happyReduction_30
happyReduction_30 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_31 = happyReduce 6 6 happyReduction_31
happyReduction_31 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_32 = happyReduce 8 6 happyReduction_32
happyReduction_32 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_33 = happySpecReduce_3  6 happyReduction_33
happyReduction_33 _
	_
	_
	 =  HappyAbsSyn6
		 (()
	)

happyReduce_34 = happyReduce 5 6 happyReduction_34
happyReduction_34 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_35 = happyReduce 5 6 happyReduction_35
happyReduction_35 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_36 = happyReduce 7 6 happyReduction_36
happyReduction_36 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_37 = happyReduce 5 6 happyReduction_37
happyReduction_37 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_38 = happyReduce 4 6 happyReduction_38
happyReduction_38 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (()
	) `HappyStk` happyRest

happyReduce_39 = happySpecReduce_3  6 happyReduction_39
happyReduction_39 _
	_
	_
	 =  HappyAbsSyn6
		 (()
	)

happyReduce_40 = happySpecReduce_3  6 happyReduction_40
happyReduction_40 _
	_
	_
	 =  HappyAbsSyn6
		 (()
	)

happyNewToken action sts stk [] =
	action 21 21 notHappyAtAll (HappyState action) sts stk []

happyNewToken action sts stk (tk:tks) =
	let cont i = action i i tk (HappyState action) sts stk tks in
	case tk of {
	TokenMember -> cont 7;
	TokenContainedIn -> cont 8;
	TokenCompound -> cont 9;
	TokenBasedOn -> cont 10;
	TokenLocatedAt -> cont 11;
	TokenRefersTo -> cont 12;
	TokenRefVar -> cont 13;
	TokenRefFunction -> cont 14;
	TokenRefClass -> cont 15;
	TokenRefFile -> cont 16;
	TokenInheritClass -> cont 17;
	TokenImplements -> cont 18;
	TokenWrappee -> cont 19;
	TokenElem happy_dollar_dollar -> cont 20;
	_ -> happyError' (tk:tks)
	}

happyError_ tk tks = happyError' (tk:tks)

newtype HappyIdentity a = HappyIdentity a
happyIdentity = HappyIdentity
happyRunIdentity (HappyIdentity a) = a

instance Monad HappyIdentity where
    return = HappyIdentity
    (HappyIdentity p) >>= q = q p

happyThen :: () => HappyIdentity a -> (a -> HappyIdentity b) -> HappyIdentity b
happyThen = (>>=)
happyReturn :: () => a -> HappyIdentity a
happyReturn = (return)
happyThen1 m k tks = (>>=) m (\a -> k a tks)
happyReturn1 :: () => a -> b -> HappyIdentity a
happyReturn1 = \a tks -> (return) a
happyError' :: () => [Token] -> HappyIdentity a
happyError' = HappyIdentity . parseError

parseRSF tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse action_0 tks) (\x -> case x of {HappyAbsSyn4 z -> happyReturn z; _other -> notHappyAtAll })

happySeq = happyDontSeq


data Token
      = TokenMember
      | TokenContainedIn
      | TokenCompound
      | TokenBasedOn
      | TokenLocatedAt
      | TokenRefersTo
      | TokenRefVar
      | TokenRefFunction
      | TokenRefClass
      | TokenRefFile
      | TokenInheritClass
      | TokenImplements
      | TokenWrappee
      | TokenElem String

instance Show Token where
    show TokenMember = "MEMBER"
    show TokenContainedIn = "CONTAINEDIN"
    show TokenCompound = "COMPOUND"
    show TokenBasedOn = "BASEDON"
    show TokenLocatedAt = "LOCATEDAT"
    show TokenRefersTo = "REFERSTO"
    show TokenRefVar = "REFvariable"
    show TokenRefFunction = "REFfunction"
    show TokenRefClass = "refClass"
    show TokenRefFile = "refFile"
    show TokenInheritClass = "inheritClass"
    show TokenImplements = "implements"
    show TokenWrappee = "__wrappee__"
    show (TokenElem str) = str

parseError :: [Token] -> a
parseError [] = error "Parse error"
parseError (x:xs) = error ("Parse error before : \"" 
    ++ (foldr (++) "" (map (' ':) (map show (take 12 (x:xs))))) 
    ++ "\"")
    
unBrk :: String -> String
unBrk [] = error "unBrk: lost brackets"
unBrk "()" = ""
unBrk (x:xs) = x:(unBrk xs)

unBrk2 :: String -> String -- only to discern from unBrk
unBrk2 [] = "" --no error here
unBrk2 "()" = ""
unBrk2 (x:xs) = x:(unBrk2 xs)

-- lexer
-- note that '"' may not be part of any reserved word
lexer :: String -> [Token]
lexer [] = []
lexer (c:cs) 
      | isSpace c = lexer cs
      | c=='"' = lexVarQuote cs
      | otherwise = lexVar (c:cs)


lexVar cs =
   case span (\x -> not(isSpace x)) cs of
      ("MEMBER",rest) -> TokenMember : lexer rest
      ("CONTAINEDIN",rest) -> TokenContainedIn : lexer rest
      ("COMPOUND",rest) -> TokenCompound : lexer rest
      ("BASEDON",rest)  -> TokenBasedOn : lexer rest
      ("LOCATEDAT",rest) -> TokenLocatedAt : lexer rest
      ("REFERSTO",rest) -> TokenRefersTo : lexer rest
      ("REFvariable",rest) -> TokenRefVar : lexer rest
      ("REFfunction",rest) -> TokenRefFunction : lexer rest
      ("refClass",rest) -> TokenRefClass : lexer rest
      ("refFile",rest) -> TokenRefFile : lexer rest
      ("inheritClass",rest) -> TokenInheritClass : lexer rest
      ("implements",rest) -> TokenInheritClass : lexer rest
      (var,rest)   -> if (isInfixOf "__wrappee__" var) 
          then let tupel = (splitAtWrappee var) 
              in ((TokenElem (fst tupel))
                 :(TokenWrappee
                    :((TokenElem (snd tupel))
                       : lexer rest))) 
          else (TokenElem var) : lexer rest

lexVarQuote cs = 
   case span (\x -> x/='"') cs of 
      (var,rest)   -> (TokenElem ('"' : (var++"\""))) : lexer (tail rest)

-- splits a string at "__wrappee__", resulting in two strings,
-- the prefix before and the suffix after.
-- The given string must contain "__wrappee__"
splitAtWrappee :: String -> (String,String)
splitAtWrappee [] = error "splitAtWrappee: given string did not contain __wrappee__"
splitAtWrappee (s:ss) | isPrefixOf "__wrappee__" (s:ss) = ("", (drop 10 ss))
                      | otherwise = let tupel = splitAtWrappee ss in
                                    (s:(fst tupel), snd tupel)


-- discards comments
removeComments :: String -> String
removeComments [] = ""
removeComments ('#':xs) = discardLine xs
    where discardLine :: String -> String --until EOL
          discardLine [] = ""
          discardLine (x:xs) | isPrint x = discardLine xs
                             | otherwise = removeComments xs
removeComments (x:xs) = x : (removeComments xs)

main = getContents >>= print . parseRSF . lexer . removeComments
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 1 "<command-line>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 28 "templates/GenericTemplate.hs" #-}








{-# LINE 49 "templates/GenericTemplate.hs" #-}

{-# LINE 59 "templates/GenericTemplate.hs" #-}

{-# LINE 68 "templates/GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is (1), it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept (1) tk st sts (_ `HappyStk` ans `HappyStk` _) =
	happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
	 (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action

{-# LINE 155 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- HappyState data type (not arrays)



newtype HappyState b c = HappyState
        (Int ->                    -- token number
         Int ->                    -- token number (yes, again)
         b ->                           -- token semantic value
         HappyState b c ->              -- current state
         [HappyState b c] ->            -- state stack
         c)



-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state (1) tk st sts stk@(x `HappyStk` _) =
     let i = (case x of { HappyErrorToken (i) -> i }) in
--     trace "shifting the error token" $
     new_state i i tk (HappyState (new_state)) ((st):(sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state ((st):(sts)) ((HappyTerminal (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_0 nt fn j tk st@((HappyState (action))) sts stk
     = action nt j tk st ((st):(sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@(((st@(HappyState (action))):(_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_2 nt fn j tk _ ((_):(sts@(((st@(HappyState (action))):(_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_3 nt fn j tk _ ((_):(((_):(sts@(((st@(HappyState (action))):(_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k - ((1) :: Int)) sts of
	 sts1@(((st1@(HappyState (action))):(_))) ->
        	let r = fn stk in  -- it doesn't hurt to always seq here...
       		happyDoSeq r (action nt j tk st1 sts1 r)

happyMonadReduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
        happyThen1 (fn stk tk) (\r -> action nt j tk st1 sts1 (r `HappyStk` drop_stk))
       where sts1@(((st1@(HappyState (action))):(_))) = happyDrop k ((st):(sts))
             drop_stk = happyDropStk k stk

happyMonad2Reduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
       happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))
       where sts1@(((st1@(HappyState (action))):(_))) = happyDrop k ((st):(sts))
             drop_stk = happyDropStk k stk





             new_state = action


happyDrop (0) l = l
happyDrop n ((_):(t)) = happyDrop (n - ((1) :: Int)) t

happyDropStk (0) l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n - ((1)::Int)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction

{-# LINE 253 "templates/GenericTemplate.hs" #-}
happyGoto action j tk st = action j j tk (HappyState action)


-----------------------------------------------------------------------------
-- Error recovery ((1) is the error token)

-- parse error if we are in recovery and we fail again
happyFail  (1) tk old_st _ stk =
--	trace "failing" $ 
    	happyError_ tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  (1) tk old_st (((HappyState (action))):(sts)) 
						(saved_tok `HappyStk` _ `HappyStk` stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	action (1) (1) tk (HappyState (action)) sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (HappyState (action)) sts stk =
--      trace "entering error recovery" $
	action (1) (1) tk (HappyState (action)) sts ( (HappyErrorToken (i)) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions







-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--	happySeq = happyDoSeq
-- otherwise it emits
-- 	happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.

{-# LINE 317 "templates/GenericTemplate.hs" #-}
{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
