--
-- Parser for extracting element names with corresponding features 
-- out of guidsl model files
--
-- Author: Wolfgang Scholz, 2010-06
--
module GuiDSL where
import Char
import ProductLine

-- parser produced by Happy Version 1.17

data HappyAbsSyn 
	= HappyTerminal Token
	| HappyErrorToken Int
	| HappyAbsSyn4 (([DProduction], [DConstr]))
	| HappyAbsSyn5 ([DProduction])
	| HappyAbsSyn6 (DProduction)
	| HappyAbsSyn7 (DPatterns)
	| HappyAbsSyn8 (DPattern)
	| HappyAbsSyn9 (DTermSeries)
	| HappyAbsSyn10 (DTerm)
	| HappyAbsSyn11 (DOptionalTerm)
	| HappyAbsSyn12 ([DConstr])
	| HappyAbsSyn13 (DConstr)
	| HappyAbsSyn14 (DConstrExp)

type HappyReduction m = 
	   Int 
	-> (Token)
	-> HappyState (Token) (HappyStk HappyAbsSyn -> [(Token)] -> m HappyAbsSyn)
	-> [HappyState (Token) (HappyStk HappyAbsSyn -> [(Token)] -> m HappyAbsSyn)] 
	-> HappyStk HappyAbsSyn 
	-> [(Token)] -> m HappyAbsSyn

action_0,
 action_1,
 action_2,
 action_3,
 action_4,
 action_5,
 action_6,
 action_7,
 action_8,
 action_9,
 action_10,
 action_11,
 action_12,
 action_13,
 action_14,
 action_15,
 action_16,
 action_17,
 action_18,
 action_19,
 action_20,
 action_21,
 action_22,
 action_23,
 action_24,
 action_25,
 action_26,
 action_27,
 action_28,
 action_29,
 action_30,
 action_31,
 action_32,
 action_33,
 action_34,
 action_35,
 action_36,
 action_37,
 action_38,
 action_39,
 action_40,
 action_41,
 action_42,
 action_43,
 action_44,
 action_45,
 action_46 :: () => Int -> HappyReduction (HappyIdentity)

happyReduce_1,
 happyReduce_2,
 happyReduce_3,
 happyReduce_4,
 happyReduce_5,
 happyReduce_6,
 happyReduce_7,
 happyReduce_8,
 happyReduce_9,
 happyReduce_10,
 happyReduce_11,
 happyReduce_12,
 happyReduce_13,
 happyReduce_14,
 happyReduce_15,
 happyReduce_16,
 happyReduce_17,
 happyReduce_18,
 happyReduce_19,
 happyReduce_20,
 happyReduce_21,
 happyReduce_22,
 happyReduce_23,
 happyReduce_24,
 happyReduce_25 :: () => HappyReduction (HappyIdentity)

action_0 (31) = happyShift action_4
action_0 (4) = happyGoto action_5
action_0 (5) = happyGoto action_6
action_0 (6) = happyGoto action_3
action_0 _ = happyFail

action_1 (31) = happyShift action_4
action_1 (5) = happyGoto action_2
action_1 (6) = happyGoto action_3
action_1 _ = happyFail

action_2 (15) = happyShift action_7
action_2 _ = happyFail

action_3 (31) = happyShift action_4
action_3 (5) = happyGoto action_9
action_3 (6) = happyGoto action_3
action_3 _ = happyReduce_4

action_4 (16) = happyShift action_8
action_4 _ = happyFail

action_5 (32) = happyAccept
action_5 _ = happyFail

action_6 (15) = happyShift action_7
action_6 _ = happyReduce_2

action_7 (24) = happyShift action_20
action_7 (28) = happyShift action_21
action_7 (31) = happyShift action_22
action_7 (12) = happyGoto action_17
action_7 (13) = happyGoto action_18
action_7 (14) = happyGoto action_19
action_7 _ = happyFail

action_8 (22) = happyShift action_15
action_8 (31) = happyShift action_16
action_8 (7) = happyGoto action_10
action_8 (8) = happyGoto action_11
action_8 (9) = happyGoto action_12
action_8 (10) = happyGoto action_13
action_8 (11) = happyGoto action_14
action_8 _ = happyFail

action_9 _ = happyReduce_3

action_10 _ = happyReduce_5

action_11 (17) = happyShift action_36
action_11 (19) = happyShift action_37
action_11 _ = happyFail

action_12 (18) = happyShift action_35
action_12 _ = happyFail

action_13 (22) = happyShift action_15
action_13 (31) = happyShift action_34
action_13 (9) = happyGoto action_33
action_13 (10) = happyGoto action_13
action_13 _ = happyReduce_11

action_14 _ = happyReduce_9

action_15 (31) = happyShift action_32
action_15 _ = happyFail

action_16 (18) = happyReduce_12
action_16 (20) = happyShift action_30
action_16 (21) = happyShift action_31
action_16 (22) = happyReduce_12
action_16 (31) = happyReduce_12
action_16 _ = happyReduce_16

action_17 _ = happyReduce_1

action_18 (17) = happyShift action_29
action_18 _ = happyFail

action_19 (26) = happyShift action_25
action_19 (27) = happyShift action_26
action_19 (29) = happyShift action_27
action_19 (30) = happyShift action_28
action_19 _ = happyFail

action_20 (24) = happyShift action_20
action_20 (28) = happyShift action_21
action_20 (31) = happyShift action_22
action_20 (14) = happyGoto action_24
action_20 _ = happyFail

action_21 (24) = happyShift action_20
action_21 (28) = happyShift action_21
action_21 (31) = happyShift action_22
action_21 (14) = happyGoto action_23
action_21 _ = happyFail

action_22 _ = happyReduce_21

action_23 (26) = happyShift action_25
action_23 (27) = happyShift action_26
action_23 _ = happyReduce_23

action_24 (25) = happyShift action_46
action_24 (26) = happyShift action_25
action_24 (27) = happyShift action_26
action_24 _ = happyFail

action_25 (24) = happyShift action_20
action_25 (28) = happyShift action_21
action_25 (31) = happyShift action_22
action_25 (14) = happyGoto action_45
action_25 _ = happyFail

action_26 (24) = happyShift action_20
action_26 (28) = happyShift action_21
action_26 (31) = happyShift action_22
action_26 (14) = happyGoto action_44
action_26 _ = happyFail

action_27 (24) = happyShift action_20
action_27 (28) = happyShift action_21
action_27 (31) = happyShift action_22
action_27 (14) = happyGoto action_43
action_27 _ = happyFail

action_28 (24) = happyShift action_20
action_28 (28) = happyShift action_21
action_28 (31) = happyShift action_22
action_28 (14) = happyGoto action_42
action_28 _ = happyFail

action_29 (24) = happyShift action_20
action_29 (28) = happyShift action_21
action_29 (31) = happyShift action_22
action_29 (12) = happyGoto action_41
action_29 (13) = happyGoto action_18
action_29 (14) = happyGoto action_19
action_29 _ = happyReduce_18

action_30 _ = happyReduce_13

action_31 _ = happyReduce_15

action_32 (23) = happyShift action_40
action_32 _ = happyFail

action_33 _ = happyReduce_10

action_34 (20) = happyShift action_30
action_34 (21) = happyShift action_31
action_34 _ = happyReduce_12

action_35 (31) = happyShift action_39
action_35 _ = happyFail

action_36 _ = happyReduce_7

action_37 (22) = happyShift action_15
action_37 (31) = happyShift action_16
action_37 (7) = happyGoto action_38
action_37 (8) = happyGoto action_11
action_37 (9) = happyGoto action_12
action_37 (10) = happyGoto action_13
action_37 (11) = happyGoto action_14
action_37 _ = happyFail

action_38 _ = happyReduce_6

action_39 _ = happyReduce_8

action_40 _ = happyReduce_14

action_41 _ = happyReduce_17

action_42 (26) = happyShift action_25
action_42 (27) = happyShift action_26
action_42 _ = happyReduce_19

action_43 (26) = happyShift action_25
action_43 (27) = happyShift action_26
action_43 _ = happyReduce_20

action_44 _ = happyReduce_25

action_45 (27) = happyShift action_26
action_45 _ = happyReduce_24

action_46 _ = happyReduce_22

happyReduce_1 = happySpecReduce_3  4 happyReduction_1
happyReduction_1 (HappyAbsSyn12  happy_var_3)
	_
	(HappyAbsSyn5  happy_var_1)
	 =  HappyAbsSyn4
		 ((happy_var_1,happy_var_3)
	)
happyReduction_1 _ _ _  = notHappyAtAll 

happyReduce_2 = happySpecReduce_1  4 happyReduction_2
happyReduction_2 (HappyAbsSyn5  happy_var_1)
	 =  HappyAbsSyn4
		 ((happy_var_1,[])
	)
happyReduction_2 _  = notHappyAtAll 

happyReduce_3 = happySpecReduce_2  5 happyReduction_3
happyReduction_3 (HappyAbsSyn5  happy_var_2)
	(HappyAbsSyn6  happy_var_1)
	 =  HappyAbsSyn5
		 (happy_var_1 : happy_var_2
	)
happyReduction_3 _ _  = notHappyAtAll 

happyReduce_4 = happySpecReduce_1  5 happyReduction_4
happyReduction_4 (HappyAbsSyn6  happy_var_1)
	 =  HappyAbsSyn5
		 ([happy_var_1]
	)
happyReduction_4 _  = notHappyAtAll 

happyReduce_5 = happySpecReduce_3  6 happyReduction_5
happyReduction_5 (HappyAbsSyn7  happy_var_3)
	_
	(HappyTerminal (TokenFeat happy_var_1))
	 =  HappyAbsSyn6
		 (DProd happy_var_1 happy_var_3
	)
happyReduction_5 _ _ _  = notHappyAtAll 

happyReduce_6 = happySpecReduce_3  7 happyReduction_6
happyReduction_6 (HappyAbsSyn7  happy_var_3)
	_
	(HappyAbsSyn8  happy_var_1)
	 =  HappyAbsSyn7
		 (DPatns happy_var_1 happy_var_3
	)
happyReduction_6 _ _ _  = notHappyAtAll 

happyReduce_7 = happySpecReduce_2  7 happyReduction_7
happyReduction_7 _
	(HappyAbsSyn8  happy_var_1)
	 =  HappyAbsSyn7
		 (DPatn happy_var_1
	)
happyReduction_7 _ _  = notHappyAtAll 

happyReduce_8 = happySpecReduce_3  8 happyReduction_8
happyReduction_8 (HappyTerminal (TokenFeat happy_var_3))
	_
	(HappyAbsSyn9  happy_var_1)
	 =  HappyAbsSyn8
		 (DSeriesPat happy_var_3 happy_var_1
	)
happyReduction_8 _ _ _  = notHappyAtAll 

happyReduce_9 = happySpecReduce_1  8 happyReduction_9
happyReduction_9 (HappyAbsSyn11  happy_var_1)
	 =  HappyAbsSyn8
		 (DSinglePat happy_var_1
	)
happyReduction_9 _  = notHappyAtAll 

happyReduce_10 = happySpecReduce_2  9 happyReduction_10
happyReduction_10 (HappyAbsSyn9  happy_var_2)
	(HappyAbsSyn10  happy_var_1)
	 =  HappyAbsSyn9
		 (DTrmS happy_var_1 happy_var_2
	)
happyReduction_10 _ _  = notHappyAtAll 

happyReduce_11 = happySpecReduce_1  9 happyReduction_11
happyReduction_11 (HappyAbsSyn10  happy_var_1)
	 =  HappyAbsSyn9
		 (DTrmSsingle happy_var_1
	)
happyReduction_11 _  = notHappyAtAll 

happyReduce_12 = happySpecReduce_1  10 happyReduction_12
happyReduction_12 (HappyTerminal (TokenFeat happy_var_1))
	 =  HappyAbsSyn10
		 (DTrm happy_var_1
	)
happyReduction_12 _  = notHappyAtAll 

happyReduce_13 = happySpecReduce_2  10 happyReduction_13
happyReduction_13 _
	(HappyTerminal (TokenFeat happy_var_1))
	 =  HappyAbsSyn10
		 (DTrmPlus happy_var_1
	)
happyReduction_13 _ _  = notHappyAtAll 

happyReduce_14 = happySpecReduce_3  10 happyReduction_14
happyReduction_14 _
	(HappyTerminal (TokenFeat happy_var_2))
	_
	 =  HappyAbsSyn10
		 (DTrmBrackets happy_var_2
	)
happyReduction_14 _ _ _  = notHappyAtAll 

happyReduce_15 = happySpecReduce_2  10 happyReduction_15
happyReduction_15 _
	(HappyTerminal (TokenFeat happy_var_1))
	 =  HappyAbsSyn10
		 (DTrmStar happy_var_1
	)
happyReduction_15 _ _  = notHappyAtAll 

happyReduce_16 = happySpecReduce_1  11 happyReduction_16
happyReduction_16 (HappyTerminal (TokenFeat happy_var_1))
	 =  HappyAbsSyn11
		 (DOptTerm happy_var_1
	)
happyReduction_16 _  = notHappyAtAll 

happyReduce_17 = happySpecReduce_3  12 happyReduction_17
happyReduction_17 (HappyAbsSyn12  happy_var_3)
	_
	(HappyAbsSyn13  happy_var_1)
	 =  HappyAbsSyn12
		 (happy_var_1 : happy_var_3
	)
happyReduction_17 _ _ _  = notHappyAtAll 

happyReduce_18 = happySpecReduce_2  12 happyReduction_18
happyReduction_18 _
	(HappyAbsSyn13  happy_var_1)
	 =  HappyAbsSyn12
		 ([happy_var_1]
	)
happyReduction_18 _ _  = notHappyAtAll 

happyReduce_19 = happySpecReduce_3  13 happyReduction_19
happyReduction_19 (HappyAbsSyn14  happy_var_3)
	_
	(HappyAbsSyn14  happy_var_1)
	 =  HappyAbsSyn13
		 (DConstrImpl happy_var_1 happy_var_3
	)
happyReduction_19 _ _ _  = notHappyAtAll 

happyReduce_20 = happySpecReduce_3  13 happyReduction_20
happyReduction_20 (HappyAbsSyn14  happy_var_3)
	_
	(HappyAbsSyn14  happy_var_1)
	 =  HappyAbsSyn13
		 (DConstrIff happy_var_1 happy_var_3
	)
happyReduction_20 _ _ _  = notHappyAtAll 

happyReduce_21 = happySpecReduce_1  14 happyReduction_21
happyReduction_21 (HappyTerminal (TokenFeat happy_var_1))
	 =  HappyAbsSyn14
		 (F happy_var_1
	)
happyReduction_21 _  = notHappyAtAll 

happyReduce_22 = happySpecReduce_3  14 happyReduction_22
happyReduction_22 _
	(HappyAbsSyn14  happy_var_2)
	_
	 =  HappyAbsSyn14
		 (happy_var_2
	)
happyReduction_22 _ _ _  = notHappyAtAll 

happyReduce_23 = happySpecReduce_2  14 happyReduction_23
happyReduction_23 (HappyAbsSyn14  happy_var_2)
	_
	 =  HappyAbsSyn14
		 (ExpNot happy_var_2
	)
happyReduction_23 _ _  = notHappyAtAll 

happyReduce_24 = happySpecReduce_3  14 happyReduction_24
happyReduction_24 (HappyAbsSyn14  happy_var_3)
	_
	(HappyAbsSyn14  happy_var_1)
	 =  HappyAbsSyn14
		 (ExpAnd happy_var_1 happy_var_3
	)
happyReduction_24 _ _ _  = notHappyAtAll 

happyReduce_25 = happySpecReduce_3  14 happyReduction_25
happyReduction_25 (HappyAbsSyn14  happy_var_3)
	_
	(HappyAbsSyn14  happy_var_1)
	 =  HappyAbsSyn14
		 (ExpOr happy_var_1 happy_var_3
	)
happyReduction_25 _ _ _  = notHappyAtAll 

happyNewToken action sts stk [] =
	action 32 32 notHappyAtAll (HappyState action) sts stk []

happyNewToken action sts stk (tk:tks) =
	let cont i = action i i tk (HappyState action) sts stk tks in
	case tk of {
	TokenEndFM -> cont 15;
	TokenColon -> cont 16;
	TokenSemicolon -> cont 17;
	TokenDColon -> cont 18;
	TokenDash -> cont 19;
	TokenPlus -> cont 20;
	TokenStar -> cont 21;
	TokenOB -> cont 22;
	TokenCB -> cont 23;
	TokenORB -> cont 24;
	TokenCRB -> cont 25;
	TokenAnd -> cont 26;
	TokenOr -> cont 27;
	TokenNot -> cont 28;
	TokenIff -> cont 29;
	TokenImplies -> cont 30;
	TokenFeat happy_dollar_dollar -> cont 31;
	_ -> happyError' (tk:tks)
	}

happyError_ tk tks = happyError' (tk:tks)

newtype HappyIdentity a = HappyIdentity a
happyIdentity = HappyIdentity
happyRunIdentity (HappyIdentity a) = a

instance Monad HappyIdentity where
    return = HappyIdentity
    (HappyIdentity p) >>= q = q p

happyThen :: () => HappyIdentity a -> (a -> HappyIdentity b) -> HappyIdentity b
happyThen = (>>=)
happyReturn :: () => a -> HappyIdentity a
happyReturn = (return)
happyThen1 m k tks = (>>=) m (\a -> k a tks)
happyReturn1 :: () => a -> b -> HappyIdentity a
happyReturn1 = \a tks -> (return) a
happyError' :: () => [Token] -> HappyIdentity a
happyError' = HappyIdentity . parseError

parseGuiDSL tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse action_0 tks) (\x -> case x of {HappyAbsSyn4 z -> happyReturn z; _other -> notHappyAtAll })

happySeq = happyDontSeq


data DProduction 
      = DProd String DPatterns
      deriving Show

data DPatterns
      = DPatns DPattern DPatterns
      | DPatn DPattern 
      deriving Show

data DPattern -- a pattern is a term series followed by a name / a single var
      = DSeriesPat String DTermSeries --beware: name of pattern first here ! 
      | DSinglePat DOptionalTerm
      deriving Show

data DTermSeries
      = DTrmS DTerm DTermSeries
      | DTrmSsingle DTerm
      deriving Show

data DTerm = DTrm String | DTrmPlus String | DTrmStar String | DTrmBrackets String
      deriving Show
data DOptionalTerm = DOptTerm String
      deriving Show

data DConstr = DConstrImpl DConstrExp DConstrExp
             | DConstrIff DConstrExp DConstrExp deriving Show
data DConstrExp = F String
                | ExpNot DConstrExp
                | ExpAnd DConstrExp DConstrExp | ExpOr DConstrExp DConstrExp deriving Show

data Token
      = TokenEndFM
      | TokenColon
      | TokenDColon
      | TokenSemicolon
      | TokenDash
      | TokenPlus
      | TokenStar
      | TokenOB
      | TokenCB
      | TokenORB
      | TokenCRB
      | TokenAnd
      | TokenOr
      | TokenNot
      | TokenIff
      | TokenImplies
      | TokenFeat String

instance Show Token where
    show TokenEndFM = "EOF"
    show TokenColon = ":"
    show TokenDColon = "::"--
-- Parser for extracting element names with corresponding features 
-- out of *.features.rsf files
--
-- Author: Wolfgang Scholz, 2010-06
--
    show TokenSemicolon = ";"
    show TokenDash = "-"
    show TokenPlus = "+"
    show TokenStar = "*"
    show TokenOB = "["
    show TokenCB = "]"
    show TokenORB = "("
    show TokenCRB = ")"
    show TokenAnd = "and"
    show TokenOr = "or"
    show TokenNot = "not"
    show TokenIff = "iff"
    show TokenImplies = "implies"
    show (TokenFeat str) = str


parseError :: [Token] -> a
parseError [] = error "Parse error"
parseError (x:xs) = error ("Parse error before : \"" 
    ++ (foldr (++) "" (map (' ':) (map show (take 12 (x:xs))))) ++ "\"")


-- lexer
lexer :: String -> [Token]
lexer [] = []
lexer ('%':('%':cs)) = TokenEndFM : lexer cs 
lexer (':':(':':cs)) = TokenDColon : lexer cs 
lexer (':':cs) = TokenColon : lexer cs
lexer (';':cs) = TokenSemicolon : lexer cs
lexer ('|':cs) = TokenDash : lexer cs
lexer ('+':cs) = TokenPlus : lexer cs
lexer ('*':cs) = TokenStar : lexer cs
lexer ('[':cs) = TokenOB : lexer cs
lexer (']':cs) = TokenCB : lexer cs
lexer ('(':cs) = TokenORB : lexer cs
lexer (')':cs) = TokenCRB : lexer cs
lexer (c:cs) 
      | isSpace c = lexer cs
      | otherwise = lexVar (c:cs)

lexVar cs =
   case span (\x -> (isAlpha x) || (isDigit x) || (x=='_')) cs of
      ("and",rest) -> TokenAnd : lexer rest
      ("or",rest) -> TokenOr : lexer rest
      ("iff",rest) -> TokenIff : lexer rest
      ("not",rest)  -> TokenNot : lexer rest
      ("implies",rest) -> TokenImplies : lexer rest
      (var,rest)   -> TokenFeat var : lexer rest

-- discards comments
removeComments :: String -> String
removeComments [] = ""
removeComments ('/':('/':xs)) = discardLine xs
    where discardLine :: String -> String --until EOL
          discardLine [] = ""
          discardLine (x:xs) | isPrint x = discardLine xs
                             | otherwise = removeComments xs
removeComments ('/':('*':xs)) = discardComment xs
    where discardComment :: String -> String --until "*/"
          discardComment [] = ""
          discardComment ('*':('/':xs)) = removeComments xs
          discardComment (x:xs) = discardComment xs
removeComments (x:xs) = x : (removeComments xs)

-- discards unneeded formatting data in GUIDSL model
discardFormatting :: String -> String
discardFormatting [] = []
discardFormatting ('#':('#':xs)) = [] --TODO: change back to '##' - constraints
discardFormatting (x:xs) = x : (discardFormatting xs)

main = getContents >>= print . parseGuiDSL . lexer . discardFormatting . removeComments
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 1 "<command-line>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 28 "templates/GenericTemplate.hs" #-}








{-# LINE 49 "templates/GenericTemplate.hs" #-}

{-# LINE 59 "templates/GenericTemplate.hs" #-}

{-# LINE 68 "templates/GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is (1), it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept (1) tk st sts (_ `HappyStk` ans `HappyStk` _) =
	happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
	 (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action

{-# LINE 155 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- HappyState data type (not arrays)



newtype HappyState b c = HappyState
        (Int ->                    -- token number
         Int ->                    -- token number (yes, again)
         b ->                           -- token semantic value
         HappyState b c ->              -- current state
         [HappyState b c] ->            -- state stack
         c)



-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state (1) tk st sts stk@(x `HappyStk` _) =
     let i = (case x of { HappyErrorToken (i) -> i }) in
--     trace "shifting the error token" $
     new_state i i tk (HappyState (new_state)) ((st):(sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state ((st):(sts)) ((HappyTerminal (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_0 nt fn j tk st@((HappyState (action))) sts stk
     = action nt j tk st ((st):(sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@(((st@(HappyState (action))):(_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_2 nt fn j tk _ ((_):(sts@(((st@(HappyState (action))):(_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_3 nt fn j tk _ ((_):(((_):(sts@(((st@(HappyState (action))):(_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k - ((1) :: Int)) sts of
	 sts1@(((st1@(HappyState (action))):(_))) ->
        	let r = fn stk in  -- it doesn't hurt to always seq here...
       		happyDoSeq r (action nt j tk st1 sts1 r)

happyMonadReduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
        happyThen1 (fn stk tk) (\r -> action nt j tk st1 sts1 (r `HappyStk` drop_stk))
       where sts1@(((st1@(HappyState (action))):(_))) = happyDrop k ((st):(sts))
             drop_stk = happyDropStk k stk

happyMonad2Reduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
       happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))
       where sts1@(((st1@(HappyState (action))):(_))) = happyDrop k ((st):(sts))
             drop_stk = happyDropStk k stk





             new_state = action


happyDrop (0) l = l
happyDrop n ((_):(t)) = happyDrop (n - ((1) :: Int)) t

happyDropStk (0) l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n - ((1)::Int)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction

{-# LINE 253 "templates/GenericTemplate.hs" #-}
happyGoto action j tk st = action j j tk (HappyState action)


-----------------------------------------------------------------------------
-- Error recovery ((1) is the error token)

-- parse error if we are in recovery and we fail again
happyFail  (1) tk old_st _ stk =
--	trace "failing" $ 
    	happyError_ tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  (1) tk old_st (((HappyState (action))):(sts)) 
						(saved_tok `HappyStk` _ `HappyStk` stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	action (1) (1) tk (HappyState (action)) sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (HappyState (action)) sts stk =
--      trace "entering error recovery" $
	action (1) (1) tk (HappyState (action)) sts ( (HappyErrorToken (i)) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions







-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--	happySeq = happyDoSeq
-- otherwise it emits
-- 	happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.

{-# LINE 317 "templates/GenericTemplate.hs" #-}
{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
